Index: palm/trunk/SCRIPTS/.mrun.config.csc_sisu
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.csc_sisu	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.csc_sisu	(revision 1914)
@@ -79,4 +79,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -104,4 +105,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.cuhk
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.cuhk	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.cuhk	(revision 1914)
@@ -84,4 +84,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -109,4 +110,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.dkrz
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.dkrz	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.dkrz	(revision 1914)
@@ -86,4 +86,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -111,4 +112,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
Index: palm/trunk/SCRIPTS/.mrun.config.forwind_flow
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.forwind_flow	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.forwind_flow	(revision 1914)
@@ -113,4 +113,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f:rec  $base_data/$fname/RESTART   _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART   _rprt
Index: palm/trunk/SCRIPTS/.mrun.config.forwind_hlrnIII
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.forwind_hlrnIII	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.forwind_hlrnIII	(revision 1914)
@@ -137,4 +137,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f:rec  $base_data/$fname/RESTART   _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART   _rprt
Index: palm/trunk/SCRIPTS/.mrun.config.gfortran
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.gfortran	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.gfortran	(revision 1914)
@@ -99,4 +99,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -124,4 +125,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.hayaka
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.hayaka	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.hayaka	(revision 1914)
@@ -71,4 +71,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -96,4 +97,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.hlrnIII
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.hlrnIII	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.hlrnIII	(revision 1914)
@@ -138,4 +138,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -163,4 +164,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.ibmh
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.ibmh	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.ibmh	(revision 1914)
@@ -84,4 +84,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -109,4 +110,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $output_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.ifort
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.ifort	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.ifort	(revision 1914)
@@ -99,4 +99,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -124,4 +125,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk	(revision 1914)
@@ -74,4 +74,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -99,4 +100,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk_gpu
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk_gpu	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk_gpu	(revision 1914)
@@ -86,4 +86,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -111,4 +112,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII	(revision 1914)
@@ -135,4 +135,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -160,4 +161,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.imuk_hlrnIII_rrtmg	(revision 1914)
@@ -138,4 +138,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -163,4 +164,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr      nc
Index: palm/trunk/SCRIPTS/.mrun.config.imuknb
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.imuknb	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.imuknb	(revision 1914)
@@ -83,4 +83,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -108,4 +109,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.kiaps
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.kiaps	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.kiaps	(revision 1914)
@@ -72,4 +72,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -97,4 +98,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.lcxe6
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.lcxe6	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.lcxe6	(revision 1914)
@@ -95,4 +95,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -120,4 +121,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.riam
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.riam	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.riam	(revision 1914)
@@ -81,4 +81,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -106,4 +107,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.tatara
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.tatara	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.tatara	(revision 1914)
@@ -70,4 +70,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f      $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf     $base_data/$fname/RESTART  _rprt
@@ -95,4 +96,8 @@
 CPU_MEASURES      out:loc:tr   d3#     $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 #
 DATA_1D_PR_NETCDF    out:loc:tr   pr#:prf   $base_data/$fname/OUTPUT  _pr     nc
Index: palm/trunk/SCRIPTS/.mrun.config.yonsei2011
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.yonsei2011	(revision 1867)
+++ palm/trunk/SCRIPTS/.mrun.config.yonsei2011	(revision 1914)
@@ -83,4 +83,5 @@
 NUDGING_DATA             in:locopt     d3#:d3f  $base_data/$fname/INPUT    _nudge
 LSF_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _lsf
+WTM_DATA                 in:locopt     d3#:d3f  $base_data/$fname/INPUT    _wtm
 BININ                    in:loc:flpe   d3f:rec   $base_data/$fname/RESTART  _d3d
 PARTICLE_RESTART_DATA_IN in:loc:flpe   prtf  $base_data/$fname/RESTART  _rprt
@@ -108,4 +109,8 @@
 CPU_MEASURES      out:loc:tr   d3#:pcr $base_data/$fname/MONITORING  _cpu
 CPU_MEASURES      out:loc:tra  d3f     $base_data/$fname/MONITORING  _cpu
+TURBINE_PARAMETERS01  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters01
+TURBINE_PARAMETERS02  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters02
+TURBINE_PARAMETERS03  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters03
+TURBINE_PARAMETERS04  out:loc:tr  d3#:d3f   $base_data/$fname/MONITORING  _turbine_parameters04
 DVRP_LOG          out:loc:tr   dv#     $base_data/$fname/MONITORING  _dvrp_log
 DVRP_LOG          out:loc:tra  dvf     $base_data/$fname/MONITORING  _dvrp_log
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 1867)
+++ palm/trunk/SCRIPTS/mrun	(revision 1914)
@@ -918,5 +918,4 @@
 
 
-
        # PROVIDE VALUES OF ENVIRONMENT-VARIABLE FOR interpret_config VIA NAMELIST-FILE
     cat  >  .mrun_environment  <<  %%END%%
@@ -927,4 +926,5 @@
                     localhost = '$localhost', output_list = '$output_list' /
 
+
 %%END%%
 
@@ -958,5 +958,4 @@
     rm .mrun_environment
 
-
        # EXECUTE SHELL-COMMANDS GENERATED BY interpret_config WITHIN THIS SHELL
     chmod  u+x  $interpreted_config_file
@@ -966,5 +965,4 @@
 
  fi
-
 
     # VALUES OF MRUN-OPTIONS OVERWRITE THOSE FROM THE CONFIGURATION-FILE
Index: palm/trunk/SCRIPTS/subjob
===================================================================
--- palm/trunk/SCRIPTS/subjob	(revision 1867)
+++ palm/trunk/SCRIPTS/subjob	(revision 1914)
@@ -907,7 +907,7 @@
     if [[ $numprocs != 0 ]]
     then
-      pe_set="#$ -pe impi $numprocs"
-    else
-      pe_set="#$ -pe impi 1"
+      pe_set="#$ -pe openmpi $numprocs"
+    else
+      pe_set="#$ -pe openmpi 1"
     fi
     if [[ $queue = default ]]