Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 1916)
+++ palm/trunk/SCRIPTS/mrun	(revision 1917)
@@ -918,4 +918,5 @@
 
 
+
        # PROVIDE VALUES OF ENVIRONMENT-VARIABLE FOR interpret_config VIA NAMELIST-FILE
     cat  >  .mrun_environment  <<  %%END%%
@@ -926,5 +927,4 @@
                     localhost = '$localhost', output_list = '$output_list' /
 
-
 %%END%%
 
@@ -958,4 +958,5 @@
     rm .mrun_environment
 
+
        # EXECUTE SHELL-COMMANDS GENERATED BY interpret_config WITHIN THIS SHELL
     chmod  u+x  $interpreted_config_file
@@ -965,4 +966,5 @@
 
  fi
+
 
     # VALUES OF MRUN-OPTIONS OVERWRITE THOSE FROM THE CONFIGURATION-FILE
Index: palm/trunk/SCRIPTS/subjob
===================================================================
--- palm/trunk/SCRIPTS/subjob	(revision 1916)
+++ palm/trunk/SCRIPTS/subjob	(revision 1917)
@@ -907,7 +907,7 @@
     if [[ $numprocs != 0 ]]
     then
-      pe_set="#$ -pe openmpi $numprocs"
-    else
-      pe_set="#$ -pe openmpi 1"
+      pe_set="#$ -pe impi $numprocs"
+    else
+      pe_set="#$ -pe impi 1"
     fi
     if [[ $queue = default ]]
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1916)
+++ palm/trunk/SOURCE/Makefile	(revision 1917)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+#
+# 1914 2016-05-26 14:44:07Z witha
+# Added wind_turbine_model_mod
 #
 # 1900 2016-05-04 15:27:53Z raasch
@@ -56,8 +59,4 @@
 # Tails removed. lpm_release_set removed. calc_precipitation, impact_of_latent_heat
 # removed. 
-#
-# 1819 2016-04-06 21:05:15Z witha
-# Added wind turbine model and renamed it from wind_turbine_model to
-# wind_turbine_model_mod
 #
 # 1817 2016-04-06 15:44:20Z maronga
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1916)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1917)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+!
+! 1914 2016-05-26 14:44:07Z witha
+! Added checks for the wind turbine model
 !
 ! 1841 2016-04-07 19:14:06Z raasch
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1916)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1917)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+!
+! 1914 2016-05-26 14:44:07Z witha
+! Added initialization of the wind turbine model
 !
 ! 1878 2016-04-19 12:30:36Z hellstea
@@ -36,7 +39,4 @@
 ! 1845 2016-04-08 08:29:13Z raasch
 ! nzb_2d replaced by nzb_u|v_inner
-! 
-! 1839 2016-04-07 18:48:14Z witha
-! Renamed calls for wind turbine model
 !
 ! 1833 2016-04-07 14:23:03Z raasch
@@ -52,7 +52,4 @@
 ! 1822 2016-04-07 07:49:42Z hoffmann
 ! icloud_scheme replaced by microphysics_*
-!
-! 1819 2016-04-06 21:05:15Z witha
-! Added initialization of the wind turbine model
 ! 
 ! 1817 2016-04-06 15:44:20Z maronga
Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 1916)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 1917)
@@ -27,7 +27,4 @@
 ! 1871 2016-04-15 11:46:09Z hoffmann
 ! Initialization of aerosols added.
-!
-! 1839 2016-04-07 18:48:14Z witha
-! Reading of &wind_turbine_par moved to wind_turbine_model_mod
 ! 
 ! 1833 2016-04-07 14:23:03Z raasch
@@ -44,7 +41,4 @@
 ! +collision_algorithm
 ! Tails removed.
-
-! 1819 2016-04-06 21:05:15Z witha
-! Added namelist for wind turbine model
 !
 ! 1817 2016-04-06 15:44:20Z maronga
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1916)
+++ palm/trunk/SOURCE/parin.f90	(revision 1917)
@@ -25,9 +25,9 @@
 ! $Id$
 !
+! 1914 2016-05-26 14:44:07Z witha
+! Added call to wind turbine model for reading of &wind_turbine_par
+!
 ! 1849 2016-04-08 11:33:18Z hoffmann
 ! Adapted for modularization of microphysics
-!
-! 1839 2016-04-07 18:48:14Z witha
-! Added call to wind turbine model for reading of &wind_turbine_par
 !
 ! 1833 2016-04-07 14:23:03Z raasch
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1916)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1917)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+!
+! 1914 2016-05-26 14:44:07Z witha
+! Added calls for wind turbine model
 !
 ! 1873 2016-04-18 14:50:06Z maronga
@@ -36,10 +39,6 @@
 ! 1822 2016-04-07 07:49:42Z hoffmann
 ! Kessler microphysics scheme moved to microphysics.
-
-! 1819 2016-04-06 21:05:15Z witha
-! Added calls for wind turbine model
 !
 ! 1757 2016-02-22 15:49:32Z maronga
-! 
 ! 
 ! 1691 2015-10-26 16:17:44Z maronga
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1916)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1917)
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1914 2016-05-26 14:44:07Z witha
+! Added call for wind turbine model
+!
 ! 1878 2016-04-19 12:30:36Z hellstea
 ! Synchronization for nested runs rewritten
@@ -42,7 +45,4 @@
 ! 1822 2016-04-07 07:49:42Z hoffmann
 ! icloud_scheme replaced by microphysics_*
-!
-! 1819 2016-04-06 21:05:15Z witha
-! Added call for wind turbine model and moved it
 !
 ! 1808 2016-04-05 19:44:00Z raasch
Index: palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 1916)
+++ palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 1917)
@@ -24,24 +24,6 @@
 ! -----------------
 ! $Id$
-!
-! 1912 2016-05-26 13:03:07Z witha
-! Added subroutine wtm_check_parameters
-! Renamed wtm_read_tables to wtm_read_blade_tables
-! Review of Pitch and Speed Control
-!
-! 1864 2016-04-14 17:23:11Z witha
-! Definition of PRIVATE and PUBLIC variables and functions
-! Relocation of some variables from module to the subroutines
-! Added subroutines wtm_speed_control and wtm_init_speed_control
-! Airfoil tables are now read from the input folder 
-!
-! 1843 2016-04-08 08:20:19Z witha
-! Bugfix and revision in reading mechanism
 ! 
-! 1839 2016-04-07 18:48:14Z witha
-! Added subroutine for parin, renamed subroutines, witha
-! Added subroutine wtm_read_tables, changes on parin, lvo
-! 
-! 1820 2016-04-06 21:08:26Z witha
+! 1914 2016-05-26 14:44:07Z witha
 ! Initial revision
 ! 
@@ -63,5 +45,5 @@
 !> @todo Implement ADM and ALM turbine models
 !> @todo Generate header information
-!> @todo Implement parameter checks and error messages
+!> @todo Implement further parameter checks and error messages
 !> @todo Revise and add code documentation
 !> @todo Output turbine parameters as timeseries