Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1918)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1919)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! setting of a fixed reference state ('single_value') for ocean runs removed
 ! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1918 2016-05-27 14:35:57Z raasch
+! setting of a fixed reference state ('single_value') for ocean runs removed
 !
 ! 1914 2016-05-26 14:44:07Z witha
Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 1918)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 1919)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! -----------------
-! in case of Wicker-Skamarock scheme, calculate disturbance kinetic energy here,
-! if flow_statistics is called before the first initial time step
 ! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1918 2016-05-27 14:35:57Z raasch
+! in case of Wicker-Skamarock scheme, calculate disturbance kinetic energy here,
+! if flow_statistics is called before the first initial time step
 !
 ! 1853 2016-04-11 09:00:35Z maronga
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 1918)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 1919)
@@ -19,11 +19,14 @@
 ! Current revisions:
 ! ------------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1918 2016-05-27 14:35:57Z raasch
 ! intermediate_timestep_count is set 0 instead 1 for first call of pres,
 ! bugfix: initialization of local sum arrays are moved to the beginning of the
 !         routine because otherwise results from pres are overwritten
-! 
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1914 2016-05-26 14:44:07Z witha
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1918)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1919)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! ------------------
-! default timestep switched from -1.0 to +1.0 in order to avoid wrong sign of
-! initially calculated divergence
-! 
+! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1918 2016-05-27 14:35:57Z raasch
+! default timestep switched from -1.0 to +1.0 in order to avoid wrong sign of
+! initially calculated divergence
 !
 ! 1906 2016-05-24 14:38:08Z suehring
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 1918)
+++ /palm/trunk/SOURCE/pres.f90	(revision 1919)
@@ -19,4 +19,11 @@
 ! Current revisions:
 ! ------------------
+!
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1918 2016-05-27 14:35:57Z raasch
 ! sum of divergence is also calculated when pres is called before the initial
 ! first time step,
@@ -26,8 +33,4 @@
 !         mean vertical velocity is also removed for the first time step
 ! bugfix for calculating divergences
-! 
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1908 2016-05-25 17:22:32Z suehring
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 1918)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 1919)
@@ -19,11 +19,14 @@
 ! Current revisions:
 ! ------------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1918 2016-05-27 14:35:57Z raasch
 ! determination of time step moved to the end of the time step loop,
 ! the first time step is now always calculated before the time step loop (i.e.
 ! also in case of restart runs)
-! 
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1914 2016-05-26 14:44:07Z witha