Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1929)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1930)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Bugfix in check for use_upstream_for_tke
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1929 2016-06-09 16:25:25Z suehring
+! Bugfix in check for use_upstream_for_tke
 !
 ! 1918 2016-05-27 14:35:57Z raasch
Index: /palm/trunk/SOURCE/lpm.f90
===================================================================
--- /palm/trunk/SOURCE/lpm.f90	(revision 1929)
+++ /palm/trunk/SOURCE/lpm.f90	(revision 1930)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! ------------------
-! Call wall boundary conditions only if particles are in the vertical range of 
-! topography.
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1929 2016-06-09 16:25:25Z suehring
+! Call wall boundary conditions only if particles are in the vertical range of 
+! topography.
 !
 ! 1822 2016-04-07 07:49:42Z hoffmann
Index: /palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_advec.f90	(revision 1929)
+++ /palm/trunk/SOURCE/lpm_advec.f90	(revision 1930)
@@ -19,15 +19,18 @@
 ! Current revisions:
 ! ------------------
-! Put stochastic equation in an extra subroutine.
-! Set flag for stochastic equation to communicate whether a particle is near 
-! topography. This case, memory and drift term are disabled in the Weil equation. 
-!
-! Enable vertical logarithmic interpolation also above topography. This case, 
-! set a lower limit for the friction velocity, as it can become very small 
-! in narrow street canyons, leading to too large particle speeds. 
+!  
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1929 2016-06-09 16:25:25Z suehring
+! Put stochastic equation in an extra subroutine.
+! Set flag for stochastic equation to communicate whether a particle is near 
+! topography. This case, memory and drift term are disabled in the Weil equation. 
+!
+! Enable vertical logarithmic interpolation also above topography. This case, 
+! set a lower limit for the friction velocity, as it can become very small 
+! in narrow street canyons, leading to too large particle speeds.
 !
 ! 1888 2016-04-21 12:20:49Z suehring
Index: /palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1929)
+++ /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1930)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Rewritten wall reflection 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1929 2016-06-09 16:25:25Z suehring
+! Rewritten wall reflection 
 !
 ! 1822 2016-04-07 07:49:42Z hoffmann
Index: /palm/trunk/SOURCE/lpm_exchange_horiz.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1929)
+++ /palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1930)
@@ -19,4 +19,11 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1929 2016-06-09 16:25:25Z suehring
 ! Bugfixes: 
 ! - reallocation of new particles 
@@ -28,8 +35,4 @@
 ! Remove unused variables
 ! Descriptions in variable declaration blocks added
-! 
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1873 2016-04-18 14:50:06Z maronga
Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 1929)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 1930)
@@ -19,4 +19,11 @@
 ! Current revisions:
 ! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 2016-06-09 16:25:25Z suehring
 ! Bugfix in determining initial particle height and grid index in case of 
 ! seed_follows_topography.
@@ -25,8 +32,4 @@
 ! Bugfix logarithmic interpolation.
 ! Initial setting of sgs_wf_part.
-! 
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1890 2016-04-22 08:52:11Z hoffmann
Index: /palm/trunk/SOURCE/lpm_init_sgs_tke.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1929)
+++ /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1930)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! sgs_wfu_par, sgs_wfv_par and sgs_wfw_par are replaced by sgs_wf_par
+! 
 ! 
 ! Former revisions:
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1929 2016-06-09 16:25:25Z suehring
+! sgs_wfu_par, sgs_wfv_par and sgs_wfw_par are replaced by sgs_wf_par
+! 
 ! 1822 2016-04-07 07:49:42Z hoffmann
 ! Unused variables removed.
Index: /palm/trunk/SOURCE/mod_particle_attributes.f90
===================================================================
--- /palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1929)
+++ /palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1930)
@@ -19,10 +19,12 @@
 ! Current revisions:
 ! ------------------
-! -sgs_wfu_par, sgs_wfv_par, sgs_wfw_par
-! + sgs_wf_par
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+! 1929 2016-06-09 16:25:25Z suehring
+! -sgs_wfu_par, sgs_wfv_par, sgs_wfw_par
+! + sgs_wf_par
 !
 ! 1871 2016-04-15 11:46:09Z hoffmann
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 1929)
+++ /palm/trunk/SOURCE/pres.f90	(revision 1930)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! Bugfix: weight_substep for initial call, replace by local variable
+! 
 !
 ! Former revisions:
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1929 2016-06-09 16:25:25Z suehring
+! Bugfix: weight_substep for initial call, replace by local variable
+! 
 ! 1918 2016-05-27 14:35:57Z raasch
 ! sum of divergence is also calculated when pres is called before the initial
Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 1929)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 1930)
@@ -19,6 +19,5 @@
 ! Current revisions:
 ! ------------------
-! Bugfix: avoid segmentation fault in case one grid point is horizontally 
-! completely surrounded by topography 
+!  
 ! 
 ! Former revisions:
@@ -26,4 +25,8 @@
 ! $Id$
 !
+! 1929 2016-06-09 16:25:25Z suehring
+! Bugfix: avoid segmentation fault in case one grid point is horizontally 
+! completely surrounded by topography
+! 
 ! 1920 2016-05-30 10:50:15Z suehring
 ! Avoid segmentation fault (see change in 1915) by different initialization of 
Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 1929)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 1930)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Bugfix: added preprocessor directives for parallel and serial mode
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! 
+! 1929 2016-06-09 16:25:25Z suehring
+! Bugfix: added preprocessor directives for parallel and serial mode
 ! 
 ! 1914 2016-05-26 14:44:07Z witha