Index: palm/trunk/SOURCE/poismg_noopt.f90
===================================================================
--- palm/trunk/SOURCE/poismg.f90	(revision 1818)
+++ palm/trunk/SOURCE/poismg_noopt.f90	(revision 1931)
@@ -1,3 +1,3 @@
-!> @file poismg.f90
+!> @file poismg_noopt.f90
 !--------------------------------------------------------------------------------!
 ! This file is part of PALM.
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Rename subroutines and cpu-measure log points to indicate _noopt version
 ! 
 ! Former revisions:
@@ -129,5 +129,5 @@
 !> @todo Further work required.
 !------------------------------------------------------------------------------!
- SUBROUTINE poismg( r )
+ SUBROUTINE poismg_noopt( r )
  
 
@@ -162,5 +162,5 @@
 
 
-    CALL cpu_log( log_point_s(29), 'poismg', 'start' )
+    CALL cpu_log( log_point_s(29), 'poismg_noopt', 'start' )
 !
 !-- Initialize arrays and variables used in this subroutine
@@ -206,5 +206,5 @@
                mgcycles < maximum_mgcycles )
  
-       CALL next_mg_level( d, p_loc, p3, r)
+       CALL next_mg_level_noopt( d, p_loc, p3, r)
 
 !
@@ -212,5 +212,5 @@
 !--    cycles to be performed
        IF ( maximum_mgcycles == 0 )  THEN
-          CALL resid( d, p_loc, r )
+          CALL resid_noopt( d, p_loc, r )
           maxerror = SUM( r(nzb+1:nzt,nys:nyn,nxl:nxr)**2 )
 
@@ -232,5 +232,5 @@
        IF ( mgcycles > 1000  .AND.  mg_cycles == -1 )  THEN
           message_string = 'no sufficient convergence within 1000 cycles'
-          CALL message( 'poismg', 'PA0283', 1, 2, 0, 6, 0 )
+          CALL message( 'poismg_noopt', 'PA0283', 1, 2, 0, 6, 0 )
        ENDIF
 
@@ -244,7 +244,7 @@
     grid_level = 0 
 
-    CALL cpu_log( log_point_s(29), 'poismg', 'stop' )
-
- END SUBROUTINE poismg
+    CALL cpu_log( log_point_s(29), 'poismg_noopt', 'stop' )
+
+ END SUBROUTINE poismg_noopt
 
 
@@ -254,5 +254,5 @@
 !> Computes the residual of the perturbation pressure.
 !------------------------------------------------------------------------------!
- SUBROUTINE resid( f_mg, p_mg, r )
+ SUBROUTINE resid_noopt( f_mg, p_mg, r )
 
 
@@ -391,5 +391,5 @@
 
 
- END SUBROUTINE resid
+ END SUBROUTINE resid_noopt
 
 
@@ -400,5 +400,5 @@
 !> scheme.
 !------------------------------------------------------------------------------!
- SUBROUTINE restrict( f_mg, r )
+ SUBROUTINE restrict_noopt( f_mg, r )
 
 
@@ -607,5 +607,5 @@
 
 
-END SUBROUTINE restrict
+END SUBROUTINE restrict_noopt
 
 
@@ -616,5 +616,5 @@
 !> to the next finer grid.
 !------------------------------------------------------------------------------!
- SUBROUTINE prolong( p, temp )
+ SUBROUTINE prolong_noopt( p, temp )
 
 
@@ -722,5 +722,5 @@
 
   
- END SUBROUTINE prolong
+ END SUBROUTINE prolong_noopt
 
 
@@ -731,5 +731,5 @@
 !> 3D-Red-Black decomposition (GS-RB) is used.
 !------------------------------------------------------------------------------!
- SUBROUTINE redblack( f_mg, p_mg )
+ SUBROUTINE redblack_noopt( f_mg, p_mg )
 
 
@@ -821,5 +821,5 @@
           IF ( .NOT. unroll )  THEN
 
-             CALL cpu_log( log_point_s(36), 'redblack_no_unroll', 'start' )
+             CALL cpu_log( log_point_s(36), 'redblack_no_unroll_noopt', 'start' )
 
 !
@@ -923,5 +923,5 @@
                 ENDDO
              ENDDO
-             CALL cpu_log( log_point_s(36), 'redblack_no_unroll', 'stop' )
+             CALL cpu_log( log_point_s(36), 'redblack_no_unroll_noopt', 'stop' )
 
           ELSE
@@ -929,5 +929,5 @@
 !
 !--          Loop unrolling along y, only one i loop for better cache use
-             CALL cpu_log( log_point_s(38), 'redblack_unroll', 'start' )
+             CALL cpu_log( log_point_s(38), 'redblack_unroll_noopt', 'start' )
              DO  ic = nxl_mg(l), nxr_mg(l), 2
                 DO  jc = nys_mg(l), nyn_mg(l), 4
@@ -1090,5 +1090,5 @@
                 ENDDO
              ENDDO
-             CALL cpu_log( log_point_s(38), 'redblack_unroll', 'stop' )
+             CALL cpu_log( log_point_s(38), 'redblack_unroll_noopt', 'stop' )
 
           ENDIF
@@ -1174,5 +1174,5 @@
 
 
- END SUBROUTINE redblack
+ END SUBROUTINE redblack_noopt
 
 
@@ -1183,5 +1183,5 @@
 !> Gather subdomain data from all PEs.
 !------------------------------------------------------------------------------!
- SUBROUTINE mg_gather( f2, f2_sub )
+ SUBROUTINE mg_gather_noopt( f2, f2_sub )
 
     USE control_parameters,                                                    &
@@ -1222,5 +1222,5 @@
 
 #if defined( __parallel )
-    CALL cpu_log( log_point_s(34), 'mg_gather', 'start' )
+    CALL cpu_log( log_point_s(34), 'mg_gather_noopt', 'start' )
 
     f2_l = 0.0_wp
@@ -1255,8 +1255,8 @@
                         nwords, MPI_REAL, MPI_SUM, comm2d, ierr )
 
-    CALL cpu_log( log_point_s(34), 'mg_gather', 'stop' )
+    CALL cpu_log( log_point_s(34), 'mg_gather_noopt', 'stop' )
 #endif
     
- END SUBROUTINE mg_gather
+ END SUBROUTINE mg_gather_noopt
 
 
@@ -1268,5 +1268,5 @@
 !>       non-blocking communication
 !------------------------------------------------------------------------------!
- SUBROUTINE mg_scatter( p2, p2_sub )
+ SUBROUTINE mg_scatter_noopt( p2, p2_sub )
 
     USE control_parameters,                                                    &
@@ -1300,13 +1300,13 @@
 
 #if defined( __parallel )
-    CALL cpu_log( log_point_s(35), 'mg_scatter', 'start' )
+    CALL cpu_log( log_point_s(35), 'mg_scatter_noopt', 'start' )
 
     p2_sub = p2(:,mg_loc_ind(3,myid)-1:mg_loc_ind(4,myid)+1, &
                   mg_loc_ind(1,myid)-1:mg_loc_ind(2,myid)+1)
 
-    CALL cpu_log( log_point_s(35), 'mg_scatter', 'stop' )
+    CALL cpu_log( log_point_s(35), 'mg_scatter_noopt', 'stop' )
 #endif
     
- END SUBROUTINE mg_scatter
+ END SUBROUTINE mg_scatter_noopt
 
 
@@ -1321,5 +1321,5 @@
 !> but leads to an increase in computing time.
 !------------------------------------------------------------------------------!
- RECURSIVE SUBROUTINE next_mg_level( f_mg, p_mg, p3, r )
+ RECURSIVE SUBROUTINE next_mg_level_noopt( f_mg, p_mg, p3, r )
 
     USE control_parameters,                                                    &
@@ -1383,5 +1383,5 @@
        ngsrb = 2 * ngsrb
 
-       CALL redblack( f_mg, p_mg )
+       CALL redblack_noopt( f_mg, p_mg )
 
        ngsrb = ngsrb / 2
@@ -1394,9 +1394,9 @@
 !
 !--    Solution on the actual grid level
-       CALL redblack( f_mg, p_mg )
+       CALL redblack_noopt( f_mg, p_mg )
 
 !
 !--    Determination of the actual residual
-       CALL resid( f_mg, p_mg, r )
+       CALL resid_noopt( f_mg, p_mg, r )
 
 !
@@ -1441,5 +1441,5 @@
                            nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) )
 
-          CALL restrict( f2_sub, r )
+          CALL restrict_noopt( f2_sub, r )
 
 !
@@ -1457,5 +1457,5 @@
 !
 !--       Gather all arrays from the subdomains on PE0
-          CALL mg_gather( f2, f2_sub )
+          CALL mg_gather_noopt( f2, f2_sub )
 
 !
@@ -1502,5 +1502,5 @@
        ELSE
 
-          CALL restrict( f2, r )
+          CALL restrict_noopt( f2, r )
 
        ENDIF
@@ -1510,5 +1510,5 @@
 !
 !--    Repeat the same procedure till the coarsest grid is reached
-       CALL next_mg_level( f2, p2, p3, r )
+       CALL next_mg_level_noopt( f2, p2, p3, r )
 
     ENDIF
@@ -1531,5 +1531,5 @@
                     mg_loc_ind(1,myid)-1:mg_loc_ind(2,myid)+1) )
 
-          CALL mg_scatter( p2, p2_sub )
+          CALL mg_scatter_noopt( p2, p2_sub )
 
 !
@@ -1601,5 +1601,5 @@
           ENDIF
 
-          CALL prolong( p2_sub, p3 )
+          CALL prolong_noopt( p2_sub, p3 )
 
 !
@@ -1616,5 +1616,5 @@
        ELSE
 
-          CALL prolong( p2, p3 )
+          CALL prolong_noopt( p2, p3 )
 
        ENDIF
@@ -1633,5 +1633,5 @@
 !
 !--    Relaxation of the new solution
-       CALL redblack( f_mg, p_mg )
+       CALL redblack_noopt( f_mg, p_mg )
 
     ENDIF
@@ -1652,5 +1652,5 @@
 
 !
-!-- Reset counter for the next call of poismg
+!-- Reset counter for the next call of poismg_noopt
     grid_level_count(grid_level) = 0
 
@@ -1668,3 +1668,3 @@
  20 CONTINUE
 
- END SUBROUTINE next_mg_level
+ END SUBROUTINE next_mg_level_noopt