Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1931)
+++ palm/trunk/SOURCE/Makefile	(revision 1932)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# poismg renamed poismg_noopt, poismg_fast_mod renamed poismg_mod
+# 
 # 
 # Former revisions:
@@ -26,4 +26,7 @@
 # $Id$
 #
+# 1931 2016-06-10 12:06:59Z suehring
+# poismg renamed poismg_noopt, poismg_fast_mod renamed poismg_mod
+# 
 # 1914 2016-05-26 14:44:07Z witha
 # Added wind_turbine_model_mod
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1931)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1932)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Rename multigrid into multigrid_noopt and multigrid_fast into multigrid
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1931 2016-06-10 12:06:59Z suehring
+! Rename multigrid into multigrid_noopt and multigrid_fast into multigrid
 !
 ! 1929 2016-06-09 16:25:25Z suehring
Index: palm/trunk/SOURCE/cpulog_mod.f90
===================================================================
--- palm/trunk/SOURCE/cpulog_mod.f90	(revision 1931)
+++ palm/trunk/SOURCE/cpulog_mod.f90	(revision 1932)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! Adjustment in character length and format statement
+! 
 ! 
 ! Former revisions:
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1931 2016-06-10 12:06:59Z suehring
+! Adjustment in character length and format statement
+! 
 ! 1850 2016-04-08 13:29:27Z maronga
 ! Module renamed
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1931)
+++ palm/trunk/SOURCE/header.f90	(revision 1932)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Rename multigrid into multigrid_noopt
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1931 2016-06-10 12:06:59Z suehring
+! Rename multigrid into multigrid_noopt
 !
 ! 1902 2016-05-09 11:18:56Z suehring
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 1931)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 1932)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Rename multigrid into multigrid_noopt and multigrid_fast into multigrid
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1931 2016-06-10 12:06:59Z suehring
+! Rename multigrid into multigrid_noopt and multigrid_fast into multigrid
 !
 ! 1910 2016-05-26 06:49:46Z raasch
Index: palm/trunk/SOURCE/poismg_mod.f90
===================================================================
--- palm/trunk/SOURCE/poismg_mod.f90	(revision 1931)
+++ palm/trunk/SOURCE/poismg_mod.f90	(revision 1932)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! Rename subroutines and cpu-measure log points to indicate default version
+! 
 ! 
 ! Former revisions:
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1931 2016-06-10 12:06:59Z suehring
+! Rename subroutines and cpu-measure log points to indicate default version
+! 
 ! 1904 2016-05-11 13:06:12Z suehring
 ! Bugfix: enable special_exchange_horiz only for finer grid levels.
Index: palm/trunk/SOURCE/poismg_noopt.f90
===================================================================
--- palm/trunk/SOURCE/poismg_noopt.f90	(revision 1931)
+++ palm/trunk/SOURCE/poismg_noopt.f90	(revision 1932)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! Rename subroutines and cpu-measure log points to indicate _noopt version
+! 
 ! 
 ! Former revisions:
@@ -25,4 +25,7 @@
 ! $Id$
 !
+! 1931 2016-06-10 12:06:59Z suehring
+! Rename subroutines and cpu-measure log points to indicate _noopt version
+! 
 ! 1762 2016-02-25 12:31:13Z hellstea
 ! Introduction of nested domain feature
Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 1931)
+++ palm/trunk/SOURCE/pres.f90	(revision 1932)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! Rename multigrid into multigrid_noopt and multigrid_fast into multigrid
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1931 2016-06-10 12:06:59Z suehring
+! Rename multigrid into multigrid_noopt and multigrid_fast into multigrid
 !
 ! 1929 2016-06-09 16:25:25Z suehring